Subject: Re: [PATCH net-next] ipv4: accept u8 in IP_TOS ancillary data

From: Jesper Dangaard Brouer <[email-masked]>
Date: Tue, 13 Sep 2016 09:07:32 +0200

On Thu, 08 Sep 2016 06:31:14 -0700
Eric Dumazet <[email-masked]> wrote:

> On Thu, 2016-09-08 at 11:15 +0200, Jesper Dangaard Brouer wrote:
> > On Wed, 07 Sep 2016 21:52:56 -0700
> > Eric Dumazet <[email-masked]> wrote:
> >   
> > > From: Eric Dumazet <[email-masked]>
> > > 
> > > In commit f02db315b8d8 ("ipv4: IP_TOS and IP_TTL can be specified as
> > > ancillary data") Francesco added IP_TOS values specified as integer.
> > > 
> > > However, kernel sends to userspace (at recvmsg() time) an IP_TOS value
> > > in a single byte, when IP_RECVTOS is set on the socket.
> > > 
> > > It can be very useful to reflect all ancillary options as given by the
> > > kernel in a subsequent sendmsg(), instead of aborting the sendmsg() with
> > > EINVAL after Francesco patch.
> > > 
> > > So this patch extends IP_TOS ancillary to accept an u8, so that an UDP
> > > server can simply reuse same ancillary block without having to mangle
> > > it.
> > > 
> > > Jesper can then augment
> > > https://github.com/netoptimizer/network-testing/blob/master/src/udp_example02.c
> > > to add TOS reflection ;)  
> > 
> > This is actually your old program ;-)
> > Do I need to change anything, as I'm just bouncing the packet back with sendmsg() ?  
> 
> I guess you want to add an option and if this option is requested by the
> user, add :
> 
> 	setsockopt(fd, SOL_IP, IP_PKTINFO, &on, sizeof(on));
> +	if (tos_reflect)
> +		setsockopt(fd, SOL_IP, IP_RECVTOS, &on, sizeof(on));
> 
> before the loop doing the recvmsg()/sendmsg() calls.

Hi Eric,

I've implemented what you suggested:
 https://github.com/netoptimizer/network-testing/commit/0758ad77a96ecb1

Now QA can use this tool to verify the kernel commit ;-)

-- 
Best regards,
  Jesper Dangaard Brouer
  MSc.CS, Principal Kernel Engineer at Red Hat
  Author of http://www.iptv-analyzer.org
  LinkedIn: http://www.linkedin.com/in/brouer